package io.provis.model;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.inject.Named;

import lombok.EqualsAndHashCode;
import lombok.Getter;

@Getter
@EqualsAndHashCode
public class Artifact {

  private String coordinate;
  private Map<String, Action> actionMap;

  public Artifact(String coordinate, List<Action> actions) {
    this.coordinate = coordinate;
    
    actionMap = new LinkedHashMap<String, Action>();
    for (Action action : actions) {
      Named javaxNamed = action.getClass().getAnnotation(Named.class);
      actionMap.put(javaxNamed.value(), action);
    }    
  }

  public Action action(String name) {
    return actionMap.get(name);
  }
}
