package io.provis.model;

import java.io.File;
import java.util.Collection;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.inject.Named;

import lombok.Data;

@Data
public class ArtifactSet {

  private ArtifactSet parent;

  private String directory;
  private String description;
  private Map<String, Artifact> artifactMap;
  private Map<String, Action> actionMap;
  private Collection<String> excludes;
  private Map<String, ProvisoArtifact> resolvedArtifacts;
  private Map<String, ProvisoArtifact> artifactMapKeyedByGA;

  public ArtifactSet(String directory, List<Artifact> artifacts, List<Action> actions) {
    this.directory = directory;
    //
    // Artifacts
    //
    artifactMap = new LinkedHashMap<String, Artifact>();
    for (Artifact artifact : artifacts) {
      artifactMap.put(artifact.getCoordinate(), artifact);
    }
    //
    // Actions
    //
    actionMap = new LinkedHashMap<String, Action>();
    for (Action action : actions) {
      Named javaxNamed = action.getClass().getAnnotation(Named.class);
      actionMap.put(javaxNamed.value(), action);
    }
  }

  public Artifact artifact(String coordinate) {
    return artifactMap.get(coordinate);
  }

  public Action action(String name) {
    return actionMap.get(name);
  }

  public Collection<Action> getActions() {
    return actionMap.values();
  }

  public List<ArtifactSet> getFileSets() {
    return null;
  }

  public void setActualOutputDirectory(File f) {
  }

  public File getActualOutputDirectory() {
    return null;
  }
}
